'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _sparkCore = require('@ciscospark/spark-core');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @class
 */
var DeviceAuthInterceptor = function (_AuthInterceptor) {
  (0, _inherits3.default)(DeviceAuthInterceptor, _AuthInterceptor);

  function DeviceAuthInterceptor() {
    (0, _classCallCheck3.default)(this, DeviceAuthInterceptor);
    return (0, _possibleConstructorReturn3.default)(this, (DeviceAuthInterceptor.__proto__ || (0, _getPrototypeOf2.default)(DeviceAuthInterceptor)).apply(this, arguments));
  }

  (0, _createClass3.default)(DeviceAuthInterceptor, [{
    key: 'requiresCredentials',


    // it's an if-tree, splitting it up into more functions makes it more
    // difficult to interpet, not less
    /* eslint-disable complexity */
    /**
     * @param {Object} options
     * @returns {Promise<boolean>}
     */
    value: function requiresCredentials(options) {
      var _this2 = this;

      if (options.uri.includes(this.spark.config.credentials.tokenUrl || this.spark.config.credentials.oauth.tokenUrl)) {
        return _promise2.default.resolve(false);
      }

      if (options.uri.includes(this.spark.config.credentials.authorizeUrl || this.spark.config.credentials.oauth.authorizeUrl)) {
        return _promise2.default.resolve(false);
      }

      if (options.uri.includes(this.spark.config.credentials.samlUrl)) {
        return _promise2.default.resolve(false);
      }

      if (options.uri.includes(this.spark.config.hydraServiceUrl)) {
        return _promise2.default.resolve(true);
      }

      return this.spark.device.isSpecificService('hydra', options.uri).then(function (isHydra) {
        if (isHydra) {
          return true;
        }

        if (options.service) {
          return _this2.spark.device.isService(options.service);
        }

        if (options.uri) {
          return _this2.spark.device.isServiceUrl(options.uri);
        }

        return _promise2.default.resolve(false);
      });
    }
    /* eslint-enable complexity */

  }], [{
    key: 'create',

    /**
     * @returns {DeviceAuthInterceptor}
     */
    value: function create() {
      /* eslint no-invalid-this: [0] */
      return new DeviceAuthInterceptor({ spark: this });
    }
  }]);
  return DeviceAuthInterceptor;
}(_sparkCore.AuthInterceptor); /**!
                                *
                                * Copyright (c) 2015-2017 Cisco Systems, Inc. See LICENSE file.
                                */

exports.default = DeviceAuthInterceptor;
//# sourceMappingURL=auth.js.map
