'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _set2 = require('lodash/set');

var _set3 = _interopRequireDefault(_set2);

var _httpCore = require('@ciscospark/http-core');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Adds 'cisco-device-url' header, as appropriate, to requests
 */
var DeviceUrlInterceptor = function (_Interceptor) {
  (0, _inherits3.default)(DeviceUrlInterceptor, _Interceptor);

  function DeviceUrlInterceptor() {
    (0, _classCallCheck3.default)(this, DeviceUrlInterceptor);
    return (0, _possibleConstructorReturn3.default)(this, (DeviceUrlInterceptor.__proto__ || (0, _getPrototypeOf2.default)(DeviceUrlInterceptor)).apply(this, arguments));
  }

  (0, _createClass3.default)(DeviceUrlInterceptor, [{
    key: 'onRequest',


    /**
    * @see Interceptor#onRequest
    * @param {Object} options
    * @returns {Object}
    */
    value: function onRequest(options) {
      var _this2 = this;

      if (!this.spark.device.url || options.headers && 'cisco-device-url' in options.headers && !options.headers['cisco-device-url']) {
        return _promise2.default.resolve(options);
      }

      return _promise2.default.resolve(options.service || this.spark.device.determineService(options.uri)).then(function (service) {
        if (service && service !== 'oauth' && service !== 'saml') {
          (0, _set3.default)(options, 'headers[\'cisco-device-url\']', _this2.spark.device.url);
        }
        return options;
      }).catch(function (err) {
        if (err.message.match(/does not reflect a known service/)) {
          return options;
        }

        throw err;
      });
    }
  }], [{
    key: 'create',

    /**
    * @returns {DeviceUrlInterceptor}
    */
    value: function create() {
      /* eslint no-invalid-this: [0] */
      return new DeviceUrlInterceptor({ spark: this });
    }
  }]);
  return DeviceUrlInterceptor;
}(_httpCore.Interceptor); /**!
                          *
                          * Copyright (c) 2015-2016 Cisco Systems, Inc. See LICENSE file.
                          */

exports.default = DeviceUrlInterceptor;
//# sourceMappingURL=device-url.js.map
